diff --git a/rsvg-filter.c b/rsvg-filter.c
index 705f14c..81cce75 100644
--- a/rsvg-filter.c
+++ b/rsvg-filter.c
@@ -608,47 +718,28 @@ rsvg_filter_get_result (GString * name, RsvgFilterContext * ctx)
 
     if (outputpointer != NULL) {
         output = *outputpointer;
-        g_object_ref (G_OBJECT (output.result));
+        cairo_surface_reference (output.surface);
         return output;
     }
 
-    g_warning (_("%s not found\n"), name->str);
+    /* g_warning (_("%s not found\n"), name->str); */
 
     output = ctx->lastresult;
-    g_object_ref (G_OBJECT (ctx->lastresult.result));
+    cairo_surface_reference (output.surface);
     return output;
 }
 
-
-static GdkPixbuf *
-rsvg_filter_get_in (GString * name, RsvgFilterContext * ctx)
-{
-    return rsvg_filter_get_result (name, ctx).result;
-}
-
 /**
- * rsvg_filter_parse: Looks up an allready created filter.
- * @defs: a pointer to the hash of definitions
- * @str: a string with the name of the filter to be looked up
- *
- * Returns a pointer to the filter that the name refers to, or NULL
- * if none was found
- **/
-RsvgFilter *
-rsvg_filter_parse (const RsvgDefs * defs, const char *str)
+ * rsvg_filter_get_in:
+ * @name:
+ * @ctx:
+ * 
+ * Returns: (transfer full) (nullable): a new #cairo_surface_t, or %NULL
+ */
+static cairo_surface_t *
+rsvg_filter_get_in (GString * name, RsvgFilterContext * ctx)
 {
-    char *name;
-
-    name = rsvg_get_url_string (str);
-    if (name) {
-        RsvgNode *val;
-        val = rsvg_defs_lookup (defs, name);
-        g_free (name);
-
-        if (val && (!strcmp (val->type->str, "filter")))
-            return (RsvgFilter *) val;
-    }
-    return NULL;
+    return rsvg_filter_get_result (name, ctx).surface;
 }
 
 static void
@@ -686,7 +777,7 @@ rsvg_filter_set_args (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * atts)
 }
 
 /**
- * rsvg_new_filter: Creates a black filter
+ * rsvg_new_filter:
  *
  * Creates a blank filter and assigns default values to everything
  **/
@@ -696,7 +787,7 @@ rsvg_new_filter (void)
     RsvgFilter *filter;
 
     filter = g_new (RsvgFilter, 1);
-    _rsvg_node_init (&filter->super);
+    _rsvg_node_init (&filter->super, RSVG_NODE_TYPE_FILTER);
     filter->filterunits = objectBoundingBox;
     filter->primitiveunits = userSpaceOnUse;
     filter->x = _rsvg_css_parse_length ("-10%");
@@ -724,8 +815,12 @@ struct _RsvgFilterPrimitiveBlend {
 };
 
 static void
-rsvg_filter_blend (RsvgFilterPrimitiveBlendMode mode, GdkPixbuf * in, GdkPixbuf * in2,
-                   GdkPixbuf * output, RsvgIRect boundarys, int *channelmap)
+rsvg_filter_blend (RsvgFilterPrimitiveBlendMode mode, 
+                   cairo_surface_t *in, 
+                   cairo_surface_t *in2,
+                   cairo_surface_t* output, 
+                   RsvgIRect boundarys, 
+                   int *channelmap)
 {
     guchar i;
     gint x, y;
@@ -733,20 +828,24 @@ rsvg_filter_blend (RsvgFilterPrimitiveBlendMode mode, GdkPixbuf * in, GdkPixbuf
     guchar *in_pixels;
     guchar *in2_pixels;
     guchar *output_pixels;
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
-    rowstride = gdk_pixbuf_get_rowstride (in);
-    rowstride2 = gdk_pixbuf_get_rowstride (in2);
-    rowstrideo = gdk_pixbuf_get_rowstride (output);
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
-    in_pixels = gdk_pixbuf_get_pixels (in);
-    in2_pixels = gdk_pixbuf_get_pixels (in2);
+    cairo_surface_flush (in);
+    cairo_surface_flush (in2);
+
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
+    rowstride = cairo_image_surface_get_stride (in);
+    rowstride2 = cairo_image_surface_get_stride (in2);
+    rowstrideo = cairo_image_surface_get_stride (output);
+
+    output_pixels = cairo_image_surface_get_data (output);
+    in_pixels = cairo_image_surface_get_data (in);
+    in2_pixels = cairo_image_surface_get_data (in2);
 
     if (boundarys.x0 < 0)
         boundarys.x0 = 0;
     if (boundarys.y0 < 0)
-        boundarys.y1 = 0;
+        boundarys.y0 = 0;
     if (boundarys.x1 >= width)
         boundarys.x1 = width;
     if (boundarys.y1 >= height)
@@ -831,8 +930,9 @@ rsvg_filter_blend (RsvgFilterPrimitiveBlendMode mode, GdkPixbuf * in, GdkPixbuf
             }
             output_pixels[4 * x + y * rowstrideo + channelmap[3]] = qr * 255.0;
         }
-}
 
+    cairo_surface_mark_dirty (output);
+}
 
 static void
 rsvg_filter_primitive_blend_render (RsvgFilterPrimitive * self, RsvgFilterContext * ctx)
@@ -841,88 +941,46 @@ rsvg_filter_primitive_blend_render (RsvgFilterPrimitive * self, RsvgFilterContex
 
     RsvgFilterPrimitiveBlend *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
-    GdkPixbuf *in2;
+    cairo_surface_t *output, *in, *in2;
 
     upself = (RsvgFilterPrimitiveBlend *) self;
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
+    if (in == NULL)
+      return;
+
     in2 = rsvg_filter_get_in (upself->in2, ctx);
+    if (in2 == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    output =
-        _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, gdk_pixbuf_get_width (in),
-                                  gdk_pixbuf_get_height (in));
+    output = _rsvg_image_surface_new (cairo_image_surface_get_width (in),
+                                      cairo_image_surface_get_height (in));
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        cairo_surface_destroy (in2);
+        return;
+    }
 
     rsvg_filter_blend (upself->mode, in, in2, output, boundarys, ctx->channelmap);
 
     rsvg_filter_store_result (self->result, output, ctx);
 
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (in2));
-    g_object_unref (G_OBJECT (output));
-}
-
-void
-rsvg_filter_adobe_blend (gint modenum, GdkPixbuf * in, GdkPixbuf * bg, GdkPixbuf * output,
-                         RsvgIRect boundarys, RsvgDrawingCtx * ctx)
-{
-    int standardmap[4] = { 0, 1, 2, 3 };
-    RsvgFilterPrimitiveBlendMode mode;
-    mode = normal;
-
-    switch (modenum) {
-    case 0:
-        mode = normal;
-        break;
-    case 1:
-        mode = multiply;
-        break;
-    case 2:
-        mode = screen;
-        break;
-    case 3:
-        mode = darken;
-        break;
-    case 4:
-        mode = lighten;
-        break;
-    case 5:
-        mode = softlight;
-        break;
-    case 6:
-        mode = hardlight;
-        break;
-    case 7:
-        mode = colordodge;
-        break;
-    case 8:
-        mode = colorburn;
-        break;
-    case 9:
-        mode = overlay;
-        break;
-    case 10:
-        mode = exclusion;
-        break;
-    case 11:
-        mode = difference;
-        break;
-    }
-
-    rsvg_filter_blend (mode, in, bg, output, boundarys, standardmap);
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (in2);
+    cairo_surface_destroy (output);
 }
 
 static void
 rsvg_filter_primitive_blend_free (RsvgNode * self)
 {
-    RsvgFilterPrimitiveBlend *upself;
-    upself = (RsvgFilterPrimitiveBlend *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    g_string_free (upself->in2, TRUE);
-    _rsvg_node_free (self);
+    RsvgFilterPrimitiveBlend *blend;
+    blend = (RsvgFilterPrimitiveBlend *) self;
+    g_string_free (blend->in2, TRUE);
+
+    rsvg_filter_primitive_free (self);
 }
 
 static void
@@ -970,15 +1028,15 @@ rsvg_new_filter_primitive_blend (void)
 {
     RsvgFilterPrimitiveBlend *filter;
     filter = g_new (RsvgFilterPrimitiveBlend, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_BLEND);
     filter->mode = normal;
     filter->super.in = g_string_new ("none");
     filter->in2 = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
         filter->super.height.factor = 'n';
-    filter->super.render = &rsvg_filter_primitive_blend_render;
-    filter->super.super.free = &rsvg_filter_primitive_blend_free;
+    filter->super.render = rsvg_filter_primitive_blend_render;
+    filter->super.super.free = rsvg_filter_primitive_blend_free;
     filter->super.super.set_atts = rsvg_filter_primitive_blend_set_atts;
     return (RsvgNode *) filter;
 }
@@ -1014,8 +1072,7 @@ rsvg_filter_primitive_convolve_matrix_render (RsvgFilterPrimitive * self, RsvgFi
 
     RsvgFilterPrimitiveConvolveMatrix *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
+    cairo_surface_t *output, *in;
 
     gint sx, sy, kx, ky;
     guchar sval;
@@ -1028,24 +1085,34 @@ rsvg_filter_primitive_convolve_matrix_render (RsvgFilterPrimitive * self, RsvgFi
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
+
+    cairo_surface_flush (in);
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    in_pixels = cairo_image_surface_get_data (in);
 
-    targetx = upself->targetx * ctx->paffine[0];
-    targety = upself->targety * ctx->paffine[3];
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
+
+    targetx = upself->targetx * ctx->paffine.xx;
+    targety = upself->targety * ctx->paffine.yy;
 
     if (upself->dx != 0 || upself->dy != 0) {
-        dx = upself->dx * ctx->paffine[0];
-        dy = upself->dy * ctx->paffine[3];
+        dx = upself->dx * ctx->paffine.xx;
+        dy = upself->dy * ctx->paffine.yy;
     } else
         dx = dy = 1;
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    rowstride = cairo_image_surface_get_stride (in);
+
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    output_pixels = cairo_image_surface_get_data (output);
 
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++) {
@@ -1109,22 +1176,24 @@ rsvg_filter_primitive_convolve_matrix_render (RsvgFilterPrimitive * self, RsvgFi
                     output_pixels[4 * x + y * rowstride + ctx->channelmap[3]] / 255;
             }
         }
+
+    cairo_surface_mark_dirty (output);
+
     rsvg_filter_store_result (self->result, output, ctx);
 
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (output));
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (output);
 }
 
 static void
 rsvg_filter_primitive_convolve_matrix_free (RsvgNode * self)
 {
-    RsvgFilterPrimitiveConvolveMatrix *upself;
+    RsvgFilterPrimitiveConvolveMatrix *convolve;
 
-    upself = (RsvgFilterPrimitiveConvolveMatrix *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    g_free (upself->KernelMatrix);
-    _rsvg_node_free (self);
+    convolve = (RsvgFilterPrimitiveConvolveMatrix *) self;
+    g_free (convolve->KernelMatrix);
+
+    rsvg_filter_primitive_free (self);
 }
 
 static void
@@ -1175,9 +1244,8 @@ rsvg_filter_primitive_convolve_matrix_set_atts (RsvgNode * self,
         if ((value = rsvg_property_bag_lookup (atts, "order"))) {
             double tempx, tempy;
             rsvg_css_parse_number_optional_number (value, &tempx, &tempy);
-            filter->orderx = tempx;
-            filter->ordery = tempy;
-
+            filter->orderx = MAX (tempx, G_MAXINT);
+            filter->ordery = MAX (tempy, G_MAXINT);
         }
         if ((value = rsvg_property_bag_lookup (atts, "kernelUnitLength")))
             rsvg_css_parse_number_optional_number (value, &filter->dx, &filter->dy);
@@ -1197,6 +1265,9 @@ rsvg_filter_primitive_convolve_matrix_set_atts (RsvgNode * self,
             rsvg_defs_register_name (ctx->priv->defs, value, &filter->super.super);
     }
 
+    if ((gint64) listlen != (gint64) filter->orderx * filter->ordery)
+        filter->orderx = filter->ordery = 0;
+
     if (filter->divisor == 0) {
         for (j = 0; j < filter->orderx; j++)
             for (i = 0; i < filter->ordery; i++)
@@ -1206,9 +1277,6 @@ rsvg_filter_primitive_convolve_matrix_set_atts (RsvgNode * self,
     if (filter->divisor == 0)
         filter->divisor = 1;
 
-    if ((gint) listlen < filter->orderx * filter->ordery)
-        filter->orderx = filter->ordery = 0;
-
     if (!has_target_x) {
         filter->targetx = floor (filter->orderx / 2);
     }
@@ -1222,19 +1290,20 @@ rsvg_new_filter_primitive_convolve_matrix (void)
 {
     RsvgFilterPrimitiveConvolveMatrix *filter;
     filter = g_new (RsvgFilterPrimitiveConvolveMatrix, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_CONVOLVE_MATRIX);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
         filter->super.height.factor = 'n';
+    filter->KernelMatrix = NULL;
     filter->divisor = 0;
     filter->bias = 0;
     filter->dx = 0;
     filter->dy = 0;
     filter->preservealpha = FALSE;
     filter->edgemode = 0;
-    filter->super.render = &rsvg_filter_primitive_convolve_matrix_render;
-    filter->super.super.free = &rsvg_filter_primitive_convolve_matrix_free;
+    filter->super.render = rsvg_filter_primitive_convolve_matrix_render;
+    filter->super.super.free = rsvg_filter_primitive_convolve_matrix_free;
     filter->super.super.set_atts = rsvg_filter_primitive_convolve_matrix_set_atts;
     return (RsvgNode *) filter;
 }
